'
' PARALLAX SCROLL DEMO for MODE 13
'
' Copyright (c) Jaws-V soft, 1997.
'
' This demo uses default SCREEN 13 palette.
' It is very fast... very very faster than SCREEN 7 version.
' (simple calculation and few memory copy)
' You can toggle vertical-sync.(WAIT &H3DA,8) by press SPACE key.
'
' send comment to: CHANGE V@aol.com
'

DEFINT A-Z

TYPE LINESCROLLTYPE
 DELAY   AS INTEGER
 COUNTER AS INTEGER
 INC     AS INTEGER
 MAX     AS INTEGER
 X       AS INTEGER
END TYPE

DECLARE SUB ChangeVCopy (SSEG, SPTR, TSEG, TPTR, SIZE)
DECLARE SUB InitCode ()
DECLARE SUB InitLine ()
DECLARE SUB InitScroll ()
DECLARE SUB InitTxtMap ()
DECLARE SUB OutputGarbage ()
DECLARE SUB UpdateLines (I)

CONST FALSE = 0
CONST TRUE = NOT FALSE

DIM SHARED CodeIsInitialized
DIM SHARED ScrollCode(9)
DIM SHARED LINES(0 TO 47) AS LINESCROLLTYPE
DIM SHARED TXTMAP(0 TO 207, 0 TO 47)  ' 512 bytes for background

InitCode
InitLine
InitTxtMap

SCREEN 13

LINE (0, 0)-(319, 199), 11, BF
OutputGarbage

VERTSYNC = TRUE

DO

 A$ = INKEY$
 ESC = (A$ = CHR$(27))
 IF A$ = " " THEN
   VERTSYNC = NOT VERTSYNC
   LOCATE 1, 34
   IF VERTSYNC THEN PRINT "-SYNC- " ELSE PRINT "-NONE- "
 END IF

 IF VERTSYNC THEN WAIT &H3DA, 8

 FOR Y = 0 TO 47

   UpdateLines Y

  '<<< remove these remark(') to test more scrolling blocks >>>

  'SEGMENT = VARSEG(TXTMAP(LINES(47 - Y).X, 47 - Y))
  'POINTER = VARPTR(TXTMAP(LINES(47 - Y).X, 47 - Y))
  'ChangeVCopy SEGMENT, POINTER, &HA000, 320 * (Y) + 320 * 8, 160

  'SEGMENT = VARSEG(TXTMAP(LINES(Y).X, Y))
  'POINTER = VARPTR(TXTMAP(LINES(Y).X, Y))
  'ChangeVCopy SEGMENT, POINTER, &HA3AC, 320 * (Y) + 320 * 8, 160
  
  'SEGMENT = VARSEG(TXTMAP(LINES(47 - Y).X, 47 - Y))
  'POINTER = VARPTR(TXTMAP(LINES(47 - Y).X, 47 - Y))
  'ChangeVCopy SEGMENT, POINTER, &HA76C, 320 * (Y) + 320 * 8, 160

   SEGMENT = VARSEG(TXTMAP(LINES(Y).X, Y))
   POINTER = VARPTR(TXTMAP(LINES(Y).X, Y))
   ChangeVCopy SEGMENT, POINTER, &HAB40, 320 * (Y) + 320 * 8, 160

  NEXT

LOOP UNTIL ESC

SYSTEM

SUB ChangeVCopy (SSEG, SPTR, TSEG, TPTR, SIZE)

 IF CodeIsInitialized THEN
   DEF SEG = VARSEG(ScrollCode(0))
   CALL ABSOLUTE(BYVAL SSEG, BYVAL SPTR, BYVAL TSEG, BYVAL TPTR, BYVAL SIZE, VARPTR(ScrollCode(0)))
   DEF SEG
 ELSE
   CLS : PRINT "Fatal Error": END
 END IF

END SUB

SUB InitCode

 ScrollCode$ = "1E5589E58B4E08C47E0AC5760EF3A55D1FCA0800"
 DEF SEG = VARSEG(ScrollCode(0))
 FOR I = 0 TO 19
   POKE VARPTR(ScrollCode(0)) + I, VAL("&H" + MID$(ScrollCode$, I * 2 + 1, 2))
 NEXT
 DEF SEG
 CodeIsInitialized = TRUE

END SUB

SUB InitLine

 '- initialize line information -
 FOR I = 0 TO 7
   LINES(I).DELAY = 0
   LINES(I).COUNTER = 0
   LINES(I).INC = 1
   LINES(I).MAX = 16
   LINES(I).X = 0
 NEXT

 FOR I = 8 TO 23
   LINES(I).DELAY = 0
   LINES(I).COUNTER = 0
   LINES(I).INC = 2
   LINES(I).MAX = 32
   LINES(I).X = 0
 NEXT

 FOR I = 24 TO 47
   LINES(I).DELAY = 0
   LINES(I).COUNTER = 0
   LINES(I).INC = 4
   LINES(I).MAX = 48
   LINES(I).X = 0
 NEXT

END SUB

SUB InitTxtMap

 DEF SEG = VARSEG(TXTMAP(0, 0))
 BLOAD "MOUNTAIN.BIN", VARPTR(TXTMAP(0, 0))
 DEF SEG

END SUB

SUB OutputGarbage

 LOCATE 1, 1: PRINT " SIMPLE PARALLAX LINESCROLL TEST -SYNC- ";
 LOCATE 2, 1: PRINT " PRESS SPACE KEY TO TOGGLE SYNC. MODE   ";
 LOCATE 3, 1: PRINT "       PRESS [ESC] KEY TO QUIT          ";
'LOCATE 4, 1: PRINT " send any comment to: CHANGEV@aol.com   ";

END SUB

SUB UpdateLines (I)

 LINES(I).X = (LINES(I).X + LINES(I).INC) MOD LINES(I).MAX

END SUB

